import numpy as np
from numpy.linalg import norm
from math import pi, sqrt,exp
import matplotlib.pyplot as plt
from matplotlib.patches import Rectangle
from scipy import stats
from scipy.stats import kstest
import matplotlib.pyplot as plt
from scipy.stats import norm as normal




#Erzeuge Poisson-Prozess
def Punkte(gamma,a,b):
    #Beachte: die "+2" ist der Einfluss von ausserhalb des Fensters
    Z = np.random.uniform(low = (-2,-2), high=(a,b), size=(np.random.poisson(gamma*(a+2)*(b+2)),2))
    #Gib die lexikographisch geordnete Liste aus (macht abfragen spaeter leichter)
    return(Z[np.lexsort(np.rot90(Z))])
                           


#Pruefe ob positive TP ueberdeckt werden
def TestPos(Z):
    return(np.delete(Z,[i for i,t in enumerate(Z) if t[0] < 0 or t[1] < 0],0))



#Sichtbare negative Tangentenpunkte bestimmen
def TestNeg(Z,M):
    N = len(Z)
    TPneg = []
    #Finde mögliche TP
    for i in range(N-1):
        j = i + 1 
        while j <= N-1 and Z[j][0] < Z[i][0] + (1 - M[i][0])*M[i][1]:
            if Z[i][1] < Z[j][1] + M[j][0]*M[j][1] and Z[j][1] < Z[i][1]:
                TPneg.append([Z[j][0],Z[i][1]])
            j = j+1
    return(np.delete(TPneg,[i for i,t in enumerate(TPneg) if t[0] < 0 or t[1] < 0],0))



#Definiere die Kernfunktion
def K(x):
    z = norm(x,2)
    if z < 1:
        Wert = 1-z**2
    else:
        Wert = 0
    return(Wert)



#Definiere die Funktion zum Flaecheberechnen
def Area(u):
    return(u[0]*u[1])



#Berechne die EPC
def Daten(gamma,a,b):
    Z = Punkte(gamma,a,b)
    N = len(Z)
    M = np.array([[x,y] for x,y in zip(np.random.randint(low=0, high=2, size=N),2*np.random.uniform(low=0.0, high=1.0, size=N))])   
    TPp = TestPos(Z)
    TPn = TestNeg(Z,M)
    Chi = len(TPp) - len(TPn)    
    folge = (a*b)**(1/6)
    sigma = sum([K((x-y)/folge)/Area([a,b]-abs(x-y)) for x in TPp for y in TPp]) + sum([K((x-y)/folge)/Area([a,b]-abs(x-y))  for x in TPn for y in TPn]) - 2*sum([K((x-y)/folge)/Area([a,b]-abs(x-y))  for x in TPp for y in TPn]) - (folge**2)*(pi/2)*((Chi/(a*b))**2)
    Normal = sqrt(a*b/sigma)*(Chi/(a*b)-(gamma-gamma**2/4))
    return(Normal,sigma)







#Testplot
def Testplot(gamma,a,b):
    #Erstelle Liste mit Punkten
    Z = Punkte(gamma,a,b)
    M = np.array([[x,y] for x,y in zip(np.random.randint(low=0, high=2, size=len(Z)),2*np.random.uniform(low=0.0, high=1.0, size=len(Z)))])   
    TPp = TestPos(Z)
    TPn = TestNeg(Z,M)
    #Fummle die Liste auseinander
    #Positive Tangentenpunkte
    xpos = [x[0] for x in TPp]
    ypos = [x[1] for x in TPp]
    #Negative Tangentenpunkte
    xneg = [x[0] for x in TPn]
    yneg = [x[1] for x in TPn]
    cmap = plt.cm.hot
    fig = plt.figure()
    ax = fig.add_subplot(111, aspect='equal')
    #Markierung M=0 heisst nach rechts, M=1 heisst nach oben
    for i in range(len(Z)):
        plt.plot([Z[i][0],Z[i][0] + (1 - M[i][0])*M[i][1]], [Z[i][1],Z[i][1] + M[i][0]*M[i][1]] , 'k-', color=(0.30,0.62,0.62))
    #Plotte alles
    plt.plot(xpos,ypos,'ob')
    plt.plot(xneg,yneg,'or')
    plt.axis([0, a, 0, b])
    plt.show()



#Defintion der empirischen VF
def ecdf(data):
    x = np.sort(data)
    n = x.size
    y = np.arange(1, n+1) / n
    return(x,y)

#Plot der VF
def Plot(data):
    x,y = ecdf(data)
    plt.scatter(x=x, y=y);
    plt.xlabel('x', fontsize=16)
    plt.ylabel('y', fontsize=16)
    x = np.linspace(-3,3,100)
    y = normal.cdf(x)
    plt.plot(x, y)
    plt.show()
